function report_purchases_invoice_analysis (reporting){
    "use strict";

    var model = openerp;

    reporting.ReportPurchaseInvoiceAnalysisWidget = reporting.Base.extend({
        template: 'ReportPurchaseInvoiceAnalysis',
        invoices: [],
        invoiceLines: [],
        productProduct:[],
        Currency:[],
        rowsData :[],
        content :[],
        rowOrigin:[],
        accountJournal:[],
        resCompany:[],
        events:{
            'click #toolbar > button' : 'clickOnAction',
            'click #X' : 'factSearch',
            'click #A' : 'factSearch',
            'click #B' : 'factSearch',
            'click #C' : 'factSearch',
            'click #D' : 'factSearch',
            'click #Z' : 'factSearch',
            'click #Y' : 'factSearch',
            'change #current-category' : 'factSearch',
            'change #current-attribute': 'factSearch',
            'change #current-attribute-value': 'factSearch',
            'click #purchase' : 'factSearch',
            'click #expense' : 'factSearch',
            'change #current-store': 'factSearch',
            'change #from' : 'factSearch',
            'change #to': 'factSearch',
            'click-row.bs.table #table' : 'ckickAnalysisDetail',
        },
        init : function(parent){
          this._super(parent);
        },
        start: function () {
            var self = this;
            var table = this.$el.find('#table');
            table.bootstrapTable({data : self.rowsData});
            this.fecthFecha();
            this.submitForm();
        },
        valorNull:function(dato){
            var valor ="";
            if (dato){
                valor=dato;
            }
            return valor;
        },
        fecthFecha: function() {
            var to;
            var dateFormat1 = "mm/dd/yy",
              from = $( "#from" )
                .datepicker({
                  dateFormat: "dd/mm/yy",
                  changeMonth: true,
                  numberOfMonths: 1,
                })
                .on( "change", function() {
                  to.datepicker( "option", "minDate", getDate(this), "dd/mm/yyyy");
                });
              to = $( "#to" ).datepicker({
                dateFormat: "dd/mm/yy",
                defaultDate: "+7d",
                changeMonth: true,
                numberOfMonths: 1,
              })
              .on( "change", function() {
                from.datepicker( "option", "maxDate", getDate(this));
              });

            function getDate( element ) {
              var fechaSel =element.value.split('/');
              var date;
              try {
                date = $.datepicker.parseDate( dateFormat1, (fechaSel[1]+"/"+fechaSel[0]+"/"+fechaSel[2]));
              } catch( error ) {
               date = null;
              }
              return date;
            }
        },
        ckickAnalysisDetail: function(e, row, $element, field){
            if (field == 'name'){
                this.do_action({
                    name : "Variantes de Producto",
                    type : 'ir.actions.act_window',
                    res_model : "product.product",
                    views : [[false,'form']],
                    target : 'new',
                    domain : [['id','=', row.id_product]],
                    context : {},
                    flags : {'form': {'action_buttons': false, 'options': {'mode': 'view'}}},
                    res_id : row.id_product,
                });
            }
            if (field == 'number'){
                this.do_action({
                    name : "Factura de Cliente",
                    type : 'ir.actions.act_window',
                    res_model : "account.invoice",
                    views : [[false,'form']],
                    target : 'new',
                    domain : [['type', '=', 'out_invoice'],['id','=', row.id]],
                    context : {},
                    flags : {'form': {'action_buttons': false, 'options': {'mode': 'view'}}},
                    res_id : row.id,
                });
            }
            e.stopImmediatePropagation();
        },
        submitForm: function () {
            var self = this;
            this.fetchResCurrencyRate().then(function(ResCurrencyRate) {
                self.ResCurrencyRate = ResCurrencyRate;
                return ResCurrencyRate;
            }).then(function (ResCurrencyRate) {
                return self.fecthResStore();
            }).then(function(ResStore){
                self.ResStore = ResStore;
                self.$el.find('#current-store').append('<option value="9999999">Todas las SUC.</option>');
                _.each(ResStore,function(item){
                    self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
                 return self.fecthAccountJournal();
            }).then(function(AccountJournal){
                self.AccountJournal = AccountJournal;
                return self.fetchAccountInvoice();
            }).then(function (AccountInvoice){
                self.AccountInvoice = AccountInvoice;
                return self.fetchAccountInvoiceLine();
            }).then(function (AccountInvoiceLine) {
                self.AccountInvoiceLine = AccountInvoiceLine;
                return self.fetchProductProduct();
            }).then(function(ProductProduct){
                self.ProductProduct = ProductProduct;
                return self.fetchProductAttribute();
            }).then(function (ProductAttribute) {
                self.ProductAttribute = ProductAttribute;
                if(ProductAttribute.length > 0){
                    self.$el.find('#current-attribute').append('<option value="9999999">Todos los atributos</option>');
                    _.each(ProductAttribute,function(item){
                        self.$el.find('#current-attribute').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.attribute').css('display','none');
                }
                return self.fetchProductAttributeValue();
            }).then(function(ProductAttributeValue){
                self.ProductAttributeValue = ProductAttributeValue;
                if(ProductAttributeValue.length > 0){
                    self.$el.find('#current-attribute-value').append('<option value="9999999">Todos los valores de atributos</option>');
                    _.each(ProductAttributeValue,function(item){
                        self.$el.find('#current-attribute-value').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.attribute-value').css('display','none');
                }
                return self.fetchProductCategory();
            }).then(function(ProductCategory){
                self.ProductCategory = ProductCategory;
                self.$el.find('#current-category').append('<option value="9999999">Todos las categorias</option>');
                _.each(ProductCategory, function (item) {
                    self.$el.find('#current-category').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
                return self.fecthResCompany();
            }).then(function(ResCompany){
                self.ResCompany = ResCompany;
            return self.fetchResPartner();
            }).then(function(ResPartner){
                self.ResPartner = ResPartner;
                self.search();
                self.searchProduct();
                return self.getInvoiceCurrency();
            });
        },
        fecthResStore: function(){
            var self = this;
            var defer = $.Deferred();
            var field=['id', 'name'];
            var ResStore = new model.web.Model('res.store');
            ResStore.query(field).all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },
        fecthAccountJournal: function(){
            var self = this;
            var defer = $.Deferred();
            var field = ['id', 'name','store_ids'];
            var domain = [['active','=',true],['type','in',['sale','purchase']]];
            var AccountJournal = new model.web.Model('account.journal');
            AccountJournal.query(field).filter(domain).all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },
        fetchResCurrencyRate: function () {
            var defer = $.Deferred();
            var fields = ['id', 'name', 'currency_id', 'rate', 'create_date'];

            var domain = [['currency_id', 'in', [166 , 20, 7, 3]]];
            var ResCurrencyRate = new model.web.Model('res.currency.rate');
            ResCurrencyRate.query(fields).filter(domain).all().then(function (results) {
                defer.resolve(results);
            });
            return defer;
        },
        fetchAccountInvoice: function () {
            var filter = [['state', 'in',['open','paid']],['type', '=', 'in_invoice']];
            var journal_ids = _.flatten(_.map(this.AccountJournal, function (item) {
                return item.id;
            }));
            var field =['id', 'type', 'number', 'origin', 'state', 'journal_id', 'currency_id', 'invoice_line','date_invoice','partner_id'];
            var defer = $.Deferred();
            var AccountInvoice = new model.web.Model('account.invoice');
            AccountInvoice.query(field).filter(filter).all().then(function (results) {
                defer.resolve(results);
            });
            return defer;
        },
        fetchAccountInvoiceLine: function () {
            var self = this;
            var defer = $.Deferred();
            var linesIds = _.flatten(_.map(self.AccountInvoice, function (item) {
                return item.invoice_line;
            }));
            var InvoiceLine = new model.web.Model('account.invoice.line');
            InvoiceLine.query(['id', 'quantity', 'price_unit', 'discount', 'name', 'product_id', 'origin','invoice_id']).filter([['id', 'in', linesIds]]).all().then(function (results) {
                defer.resolve(results)
            });
            return defer;
        },

        fetchProductProduct: function(){
            var self = this;
            var product_ids = _.flatten(_.map(self.AccountInvoiceLine, function (item) {
                return item.product_id[0];
            }));
            var domain = [['id','in',product_ids]];
            var ProductProduct = new model.web.Model('product.product');
            return ProductProduct.call('getProductProduct',[domain], {
                context: new model.web.CompoundContext()
            });
        },

        // Buscar Category
        fetchProductCategory: function(){
            var self = this;
            var defer = $.Deferred();
            var fields = ['id','name','parent_id','complete_name'];
            var ProductCategory = new model.web.Model('product.category');
            ProductCategory.query(fields).filter().all().then(function(results) {
                defer.resolve(results);
            });
            return defer;
        },

        fetchProductAttribute : function(){
            var self = this;
            var defer = $.Deferred();
            var fields = ['id','name'];
            var ProductAttribute = new model.web.Model('product.attribute');
            ProductAttribute.query(fields).filter().all().then(function(results) {
                defer.resolve(results);
            });
            return defer;
        },

        fetchProductAttributeValue : function(){
            var self = this;
            var defer = $.Deferred();
            var fields = ['id','name','attribute_id'];
            var ProductAttributeValue = new model.web.Model('product.attribute.value');
            ProductAttributeValue.query(fields).filter().all().then(function(results) {
                defer.resolve(results);
            });
            return defer;
        },

        fecthResCompany: function(){
            var self = this;
            var defer = $.Deferred();
            var currency = new model.web.Model('res.company');
            var field=['id', 'currency_id'];
            var domain=[['id','=',1]];
            currency.query(field).filter(domain).all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },
        fetchResPartner: function () {
            var self = this;
            var defer = $.Deferred();
            var ResPartner = new model.web.Model('res.partner');
            ResPartner.query(['id','name','ruc']).filter([['active', '=', true],['supplier', '=', true]]).all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },
        getAccountInvoice: function (id){
            return _.find(this.AccountInvoice, function (inv) {
                return _.contains(inv.invoice_line, id);
            });
        },
        // Obtener las lineas de las Facturas
        getProductProduct: function(pro_id){
            var self = this;
            return _.find(self.ProductProduct, function(prod){
                return _.contains(pro_id, prod.id);
            });
        },

        getResCurrencyRate: function (id){
            var self = this;
            return _.find(self.ResCurrencyRate,function (item) {
                return _.contains(item.currency_id,id);
            });
        },

        getInvoiceCurrency: function(){
            var self = this;
            for (var i = 0; i < self.AccountInvoice.length; i++) {
                var currency_new;
                var item = self.AccountInvoice[i];
                var id = item.currency_id[0];
                currency_new = self.getResCurrencyRate(id);
                if (!currency_new){
                    currency_new={};
                    currency_new.rate=1;
                }
                self.AccountInvoice[i].rate=(currency_new.rate);
            }
            return this.BuildTable();
        },
        getAccountJournal: function (id) {
            var self = this;
            return _.filter(self.AccountJournal,function (item) {
                return item.id === id;
            });
        },
        BuildTable: function(){
            var self = this;
            var data=[];
            var item;
            var invoice;
            var store;
            var product = [];
            var invoice_type;
            for (var i = 0; i < this.AccountInvoiceLine.length; i++) {
                item = this.AccountInvoiceLine[i];
                invoice = this.getAccountInvoice(item.id);
                if(invoice.origin == false){
                    invoice_type = 'expense'
                }else{
                    invoice_type = 'purchase'
                }
                product =this.getProductProduct(item.product_id);

                if (product != undefined){
                    store = self.getAccountJournal(invoice.journal_id[0]);
                    if(store.length > 0){
                        data.push({
                            id : invoice.id,
                            number : (invoice.number),
                            product_id : item.product_id[0],
                            product_name : item.name,
                            ean13 : self.valorNull(product.ean13),
                            quantity : accounting.formatNumber((item.quantity),0, ".", ","),
                            price_unity : accounting.formatNumber((item.price_unit / invoice.rate),2, ".", ","),
                            standar_tot : accounting.formatNumber((item.quantity * item.price_unit),2, ".", ","),
                            journal_id :(invoice.journal_id[0]),
                            journal_name :(invoice.journal_id[1]),
                            date_invoice : (invoice.date_invoice),
                            partner_id : invoice.partner_id[0],
                            date_create :moment(invoice.date_invoice).format("DD/MM/YYYY"),
                            amount : (item.quantity * item.price_unit),
                            partner_name : invoice.partner_id[1],
                            category_id : product.categ_id.id,
                            category_name : product.categ_id.complete_name,
                            invoice_type : invoice_type,
                            store_id : store[0].store_ids[0]
                        });
                    }
                }
            }
            self.content = data;
            this.loadTable(data);
        },
        factSearch: function(){
            var self = this;
            var today = moment().format('YYYY-MM-DD');
            var yesterday = moment().add(-1, 'days').format('YYYY-MM-DD');
            var month = moment().format('YYYY-MM');
            var last_month = moment().add(-1, 'months').format('YYYY-MM');
            var partner = this.$el.find('#partner').val().split('-');
            var product = this.$el.find('#product').val().split('-');
            var categ_ids = [];
            var category = self.$el.find('#current-category').val();
            var attribute = self.$el.find('#current-attribute').val();
            var attribute_value = self.$el.find('#current-attribute-value').val();
            var store =this.$el.find('#current-store').val();
            var desde =this.$el.find('#from').val();
            var hasta =this.$el.find('#to').val();
            var content = self.content;

            if ($('#A').is(":checked")){
                content = _.filter(content, function (inv){
                    return moment(inv.date_invoice).format('YYYY-MM-DD') == today;
                });
            }
            if ($('#B').is(":checked")){
                content = _.filter(content, function (inv){
                    return moment(inv.date_invoice).format('YYYY-MM-DD') == yesterday;
                });
            }
            if ($('#C').is(":checked")){
                content = _.filter(content, function (inv){
                    return moment(inv.date_invoice).format('YYYY-MM') == month;
                });
            }
            if ($('#D').is(":checked")){
                content = _.filter(content, function (inv){
                    return moment(inv.date_invoice).format('YYYY-MM') == last_month;                });
            }
            if ($('#Z').is(":checked")){
                $('#datepicker').css('display','block');
                if (desde.length > 0){
                    var date= desde.split('/');
                    content = _.filter(content, function (inv){
                        return inv.date_invoice >= (date[2]+"-"+date[1]+"-"+date[0]);
                    });
                }
                if (hasta.length > 0){
                    var date= hasta.split('/');
                    content = _.filter(content, function (inv){
                        return inv.date_invoice <= (date[2]+"-"+date[1]+"-"+date[0]);
                    });
                }
            }else{
                $('#datepicker').css('display','none');
            }

            if ($('#purchase').is(":checked")){
                content = _.filter(content, function (inv){
                    return inv.invoice_type == 'purchase';
                });
            }
            if ($('#expense').is(":checked")){
                content = _.filter(content, function (inv){
                    return inv.invoice_type == 'expense';
                });
            }

            if (partner != ""){
                content = _.filter(content, function(inv){
                    return inv.partner_id == partner[0];
                });
            }

            if (product != ""){
                content = _.filter(content, function(inv){

                    return inv.id_product == product[0];
                });
            }

            if (store != 9999999){
                content =_.filter(content, function (inv){
                    return inv.store_id == store;
                });
            }

            if(category){
                // Nivel 0, nivel 1
                var category_ids = _.map(_.filter(self.ProductCategory,function (item) {
                    return item.id == category || item.parent_id[0] == category;
                }), function(map){
                    return map.id;
                });

                // Nivel 0, nivel 1, nivel 2
                var category_children_ids = _.map(_.filter(self.ProductCategory,function (item) {
                    return _.contains(category_ids, item.parent_id[0]) || item.id == category;
                }), function(map){
                    return map.id;
                });

                var category_grandchildren_ids = _.map(_.filter(self.ProductCategory,function (item) {
                    return _.contains(category_children_ids, item.parent_id[0]) || item.id == category;
                }), function(map){
                    return map.id;
                }) ;

                categ_ids =  _.map(_.filter(self.ProductCategory,function (item) {
                    return _.contains(category_grandchildren_ids, item.parent_id[0]) || item.id == category;
                }), function(map){
                    return map.id;
                });
            };

            if(category && category != 9999999){
                content = _.filter(content,function (inv) {
                    return _.contains(categ_ids, inv.category_id);
                });
            }

            if(attribute && attribute != 9999999 && attribute_value == 9999999){
                content = _.filter(content,function (inv) {
                    return _.contains(inv.attribute_ids, parseInt(attribute));
                });
            }

            if(attribute_value && attribute_value != 9999999){
                content = _.filter(content,function (inv) {
                    return _.contains(inv.attribute_value_ids, parseFloat(attribute_value));
                });
            }

            var amount_total_total = _.reduce(_.map(content,function(map){
                return(map.amount);
            }),function(memo, num){
                return memo + num;
            },0);

            content.push({
                number: "Totales:",
                standar_tot: accounting.formatNumber((amount_total_total),2,".",","),
            });

            self.loadTable(content);
        },
        search: function () {
            var self = this;
            var results = self.ResPartner;
            results = _.map(results, function (item) {
                return {
                        label: item.id + '-'+ item.name + ' ' + self.valorNull(item.ruc),
                        value: item.id + '-'+ item.name + ' ' + self.valorNull(item.ruc)
                }
            });
            self.$('#partner').autocomplete({
                source: results,
                minLength:0,
                search: function(event, ui) {
                    if (!(self.$('#partner').val())){
                        self.factSearch();
                    }
                },
                close: function( event, ui ) {
                        self.factSearch();
                },
                select: function(event, ui) {
                    self.factSearch();
                }
            });
        },
        searchProduct: function () {
            var self = this;
            var results = self.ProductProduct;
            results = _.map(results, function (item) {
                return {
                    label: item.id + '- '+ ' [ ' + self.valorNull(item.default_code) + ' - ' + self.valorNull(item.ean13) + ' ] ' + item.name + ' ( ' +  self.valorNull(item.attribute_str) + ' ) ' ,
                    value: item.id + '- '+ ' [ ' + self.valorNull(item.default_code) + ' - ' + self.valorNull(item.ean13) + ' ] ' + item.name + ' ( ' +  self.valorNull(item.attribute_str) + ' ) '
                }
            });
            self.$('#product').autocomplete({
                source: results,
                minLength:0,
                search: function(event, ui) {
                    if (!(self.$('#product').val())){
                        self.factSearch();
                    }
                },
                close: function( event, ui ) {
                        self.factSearch();
                },
                select: function(event, ui) {
                    self.factSearch();
                }
            });
        },
        loadTable:function(rowsTable){
            var self = this;
            self.rowsData = rowsTable;
            var table = this.$el.find('#table');
            table.bootstrapTable('load', rowsTable);
        },

        getObjetPdf: function(rowsTable){
            var self = this;
            var rows=self.rowsData;

            return rows;
        },

        clickOnAction: function (e) {
            var self = this;
            var rowsNew;
            var getColumns=[];
            var action = this.$el.find(e.target).val();
            var rows=[];
            rowsNew = self.getObjetPdf();
            var table = this.$el.find("#table");
            var data2 = table.bootstrapTable('getVisibleColumns');
            if (action === 'pdf') {
                var dataNEW = _.map(data2, function (val){ return val.field});
                _.each(rowsNew,function (item){
                    rows.push(_.pick(item, dataNEW));
                });
                _.each(_.map(data2,function(val){
                    return val}), function(item){
                    getColumns.push([{
                                    title: item.title,
                                    dataKey: item.field
                                }]);
                });
                this.drawPDF(_.flatten(getColumns),rows)
            }
        },
        drawPDF: function (getColumns,rows) {
            var self = this;
            var rowsPdf=[];
            var hoy = moment().format('DD/MM/YYYY');
            var desde =(this.$el.find('#from').val());
            var hasta =(this.$el.find('#to').val());
            var totalPagesExp = "{total_pages_count_string}";
            var company = _.map(self.ResCompany, function (map) {
                return map.currency_id[1];
            });

            var pdfDoc = new jsPDF();

            pdfDoc.autoTable(getColumns, rows, {
                styles: { overflow: 'linebreak', fontSize: 7, columnWidth: 'wrap'},
                columnStyles: {
                    number: {columnWidth: 23},
                    date_create :{columnWidth: 18},
                    partner_name :{columnWidth: 35},
                    ean13:{columnWidth: 14},
                    product_name :{columnWidth: 70},
                    category_name : {columnWidth: '8px'},
                    price_unity : {halign:'right' },
                    quantity :{halign:'right' },
                    standar_tot : {halign:'right' },
                },
                margin: { top: 20, horizontal: 7},
                addPageContent: function (data) {
                    pdfDoc.setFontSize(12);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text('Análisis de facturas de compra ',80,10);

                    var tipo = '';
                    if ($('#Y').is(":checked")){
                        tipo = tipo.concat(' Tipo de factura : Todas las facturas' );
                    }
                    if ($('#purchase').is(":checked")){
                        tipo = tipo.concat(' Tipo de factura : Compras' );
                    }
                    if ($('#expense').is(":checked")){
                        tipo = tipo.concat(' Tipo de factura : Gastos' );
                    }
                    pdfDoc.setFontSize(9);
                    pdfDoc.setFontStyle('normal');
                    pdfDoc.setTextColor(40)
                    pdfDoc.text(6,14,tipo);

                    var fecha = '';
                    if ($('#X').is(":checked")){
                        fecha = fecha.concat(' Filtro de fecha : Sin Filtros' );
                    }
                    if ($('#A').is(":checked")){
                        fecha = fecha.concat(' Filtro de fecha : Hoy' );
                    }
                    if ($('#B').is(":checked")){
                        fecha = fecha.concat(' Filtro de fecha : Ayer' );
                    }
                    if ($('#C').is(":checked")){
                        fecha = fecha.concat(' Filtro de fecha : Mes Actual' );
                    }
                    if ($('#D').is(":checked")){
                        fecha = fecha.concat(' Filtro de fecha : Mes Pasado' );
                    }
                    if ($('#Z').is(":checked")){
                        if(desde.length > 0 || hasta.length > 0){
                            if(desde){
                                fecha=fecha.concat(' Desde: '+ desde);
                            }
                            if (hasta){
                                fecha=fecha.concat(' Hasta: '+ hasta);
                            }
                        }
                    }
                    pdfDoc.setFontSize(9);
                    pdfDoc.setFontStyle('normal');
                    pdfDoc.setTextColor(40)
                    pdfDoc.text(6,18,fecha);

                    pdfDoc.setFontSize(9);
                    pdfDoc.setFontStyle('normal');
                    pdfDoc.setTextColor(40)
                    pdfDoc.text(150,14," Fecha de Expedición: " + hoy);



                    var str = "Pagina  " + data.pageCount;
                    if (typeof pdfDoc.putTotalPages === 'function') {
                        str = str + " de " + totalPagesExp;
                    }
                    pdfDoc.setFontSize(9);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(175,pdfDoc.internal.pageSize.height - 5,str);
                }
            });

            if (typeof pdfDoc.putTotalPages === 'function') {
                pdfDoc.putTotalPages(totalPagesExp);
            }
            pdfDoc.save('Análisis de facturas de compra.pdf')
        },
    });
}
