function report_ventas_pos_orders(reporting){
    "use strict";

    var model = openerp;

    reporting.ReportVentasPosOrdersWidget = reporting.Base.extend({
        template: 'ReportVentasPosOrders',
        rowsData :[],
        modules:[],
        PosOrderLine: [],
        accountJournal:[],
        productProduct:[],
        productInvoice:[],
        invoices: [],
        invoiceLines: [],
        PosOrder: [],
        content:[],

        events:{
            'click #toolbar > button' : 'clickOnAction',
            'click #X' : 'fectSearch',
            'click #A' : 'fectSearch',
            'click #B' : 'fectSearch',
            'click #C' : 'fectSearch',
            'click #D' : 'fectSearch',
            'click #Z' : 'fectSearch',
            'change #current-store': 'fectSearch',
            'change #current-category' : 'fectSearch',
            'change #current-attribute': 'fectSearch',
            'change #current-attribute-value': 'fectSearch',
            'change #from' : 'fectSearch',
            'change #to': 'fectSearch',
            'click-row.bs.table #table' : 'clickAnalysisDetail',
        },

        init : function(parent){
          this._super(parent);
        },

        start: function () {
            var table = this.$el.find('#table');
            table.bootstrapTable({data : self.rowData});
            this.fecthFecha();
            this.submitForm();
        },

        // Redirecionar
        renderReport: function () {
            var self = this;

            var container = this.$el.closest('.oe_form_sheet.oe_form_sheet_width');
            this.$el.closest('.report_view').remove();
            container.find('.report_view').show({
                effect: 'fade',
                duration: 200,
            });
        },

        // Verificar el modelo
        checkModel : function(model){
            var self = this;
            return _.filter(self.modules,function(item){return item.name === model});
        },

        // Lanzar el mensaje
        showMensaje : function(modelos){
            var self = this;
            $("#dialog" ).dialog({
                autoOpen: true,
                resizable: false,
                modal: true,
                title: 'Atención',
                width: 500,
                open: function() {
                    $(this).html('Reporte in-disponible, contacte con el administrador del sistema ref : '+modelos);
                },
                show: {
                    effect: "fade",
                    duration: 200
                },
                hide: {
                    effect: "fade",
                    duration: 200
                },
                buttons: {
                    Aceptar: function() {
                        $(this).dialog('close');
                        self.renderReport()
                    }
                }
            });
            return
        },

        clickAnalysisDetail: function(e, row, $element, field){
            if (field == 'invoice_name'){
                this.do_action({
                    name:"Factura de cliente",
                    type: 'ir.actions.act_window',
                    res_model: "account.invoice",
                    views: [[false,'form']],
                    target: 'new',
                    domain: [['type', '=', 'out_invoice'],['id','=', row.ref]],
                    context: {},
                    flags: {'form': {'action_buttons': false, 'options': {'mode': 'view'}}},
                    res_id: row.ref,
                });
            }
            if (field == 'order_name'){
                this.do_action({
                    name:"Pos",
                    type: 'ir.actions.act_window',
                    res_model: "pos.order",
                    views: [[false,'form']],
                    target: 'new',
                    domain: [['id','=', row.order_id]],
                    context: {},
                    flags: {'form': {'action_buttons': false, 'options': {'mode': 'view'}}},
                    res_id: row.order_id,
                });
            }
            if (field == 'product_name'){
                this.do_action({
                    name : "Productos",
                    type : 'ir.actions.act_window',
                    res_model : "product.product",
                    views : [[false,'form']],
                    target : 'new',
                    domain : [['id','=', row.product_id]],
                    context : {},
                    flags : {'form': {'action_buttons': false, 'options': {'mode': 'view'}}},
                    res_id : row.product_id,
                });
            }
            e.stopImmediatePropagation();
        },

        fecthFecha: function() {
            var to;
            var dateFormat1 = "mm/dd/yy",
                from = $( "#from" )
                .datepicker({
                  dateFormat: "dd/mm/yy",
                  changeMonth: true,
                  numberOfMonths: 1,
                })
                .on( "change", function() {
                  to.datepicker( "option", "minDate", getDate(this), "dd/mm/yyyy");
                });
                to = $( "#to" ).datepicker({
                dateFormat: "dd/mm/yy",
                defaultDate: "+7d",
                changeMonth: true,
                numberOfMonths: 1,
                })
                .on( "change", function() {
                    from.datepicker( "option", "maxDate", getDate(this));
                });
            function getDate( element ) {
                var fechaSel =element.value.split('/');
                var date;
                try {
                    date = $.datepicker.parseDate( dateFormat1, (fechaSel[1]+"/"+fechaSel[0]+"/"+fechaSel[2]));
                } catch( error ) {
                    date = null;
                }
                return date;
            }
        },

        valorNull:function(dato){
            var valor ="";
            if (dato){
                valor=dato;
            }
            return valor;
        },

        // Consultar
        submitForm: function () {
            var self = this;
            self.fecthIrModuleModule().then(function(modules){
                self.modules = modules;
                return modules;
            }).then(function(modules){
                return self.fetchPosOrder();
            }).then(function(PosOrder) {
                self.PosOrder = PosOrder;
                return PosOrder;
            }).then(function (PosOrder) {
                return self.fetchPosOrderLine();
            }).then(function (PosOrderLine) {
                self.PosOrderLine = PosOrderLine;
                return self.fetchProductProduct();
            }).then(function (ProductProduct) {
                self.ProductProduct = ProductProduct;
                return self.fetchProductAttribute();
            }).then(function (ProductAttribute) {
                self.ProductAttribute = ProductAttribute;
                if(ProductAttribute.length > 0){
                    self.$el.find('#current-attribute').append('<option value="9999999">Todos los atributos</option>');
                    _.each(ProductAttribute,function(item){
                        self.$el.find('#current-attribute').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.attribute').css('display','none');
                }
                return self.fetchProductAttributeValue();
            }).then(function(ProductAttributeValue){
                self.ProductAttributeValue = ProductAttributeValue;
                if(ProductAttributeValue.length > 0){
                    self.$el.find('#current-attribute-value').append('<option value="9999999">Todos los valores de atributos</option>');
                    _.each(ProductAttributeValue,function(item){
                        self.$el.find('#current-attribute-value').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.attribute-value').css('display','none');
                }
                return self.fetchProductCategory();
            }).then(function(ProductCategory){
                self.ProductCategory= ProductCategory;
                self.$el.find('#current-category').append('<option value="9999999">Todas las categorias</option>');
                _.each(ProductCategory, function (item) {
                    self.$el.find('#current-category').append('<option value="' + item.id + '">' + item.complete_name + '</option>');
                });
                return self.fecthResStore();
            }).then(function(ResStore){
                self.ResStore = ResStore;
                self.$el.find('#current-store').append('<option value="9999999">Todas las SUC.</option>');
                _.each(ResStore,function(item){
                self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
            });
                return self.fecthAccountJournal();
            }).then(function(AccountJournal){
                self.AccountJournal = AccountJournal;
                return self.fetchAccountInvoice();
            }).then(function (AccountInvoice){
                self.AccountInvoice = AccountInvoice;
                return self.fetchAccountInvoiceLine();
            }).then(function (AccountInvoiceLine) {
                self.AccountInvoiceLine = AccountInvoiceLine;
                return self.fetchResCurrency();
            }).then(function(ResCurrency){
                self.ResCurrency = ResCurrency;
                return self.fetchResPartner();
            }).then(function (ResPartner){
                self.ResPartner = ResPartner;
                return self.fetchProductPricelist();
            }).then(function(ProductPricelist){
                self.ProductPricelist = ProductPricelist;
                return self.fecthCompanyCurrency();
            }).then(function(resCompany){
                self.resCompany = resCompany;
                self.search();
                self.searchProduct();
                return self.BuildTable();
            });
        },

        // Modelos instalados
        fecthIrModuleModule: function(){
            var self = this;
            var defer = $.Deferred();
            var fields = ['name','id'];
            var domain=[['state','=','installed']];
            var irModule = new model.web.Model('ir.module.module');

            irModule.query(fields).filter(domain).all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },

        // Obtener Pedido
        fecthResStore: function(){
            var self = this;
            var defer = $.Deferred();
            var field=['id', 'name'];
            var ResStore = new model.web.Model('res.store');
            ResStore.query(field).all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },

        fecthAccountJournal: function(){
            var self = this;
            var defer = $.Deferred();
            var field = ['id', 'name','store_ids'];
            var domain = [['active','=',true],['type','in',['sale','bank','cash']]];
            var AccountJournal = new model.web.Model('account.journal');
            AccountJournal.query(field).filter(domain).all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },

        fecthCompanyCurrency: function(){
            var self = this;
            var defer = $.Deferred();
            var field=['id','name', 'currency_id'];
            var domain = [['id', '=', self.session.company_id]];
            var ResCompany = new model.web.Model('res.company');
            ResCompany.query(field).filter(domain).all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },

        fetchProductPricelist : function(){
            var self = this;
            var defer = $.Deferred();
            var fields = ['id','name','currency_id'];
            var domain = [['active', '=', true],['type', '=', 'sale']];
            var ProductPricelist = new model.web.Model('product.pricelist');
            ProductPricelist.query(fields).filter(domain).all().then(function(results) {
                defer.resolve(results);
            });
            return defer;
        },

        // Invoice (FACTURAS)
        fetchAccountInvoice: function () {
            var self = this;
            var filter ="[['state', 'in',['open','paid']],['type', '=', 'out_invoice']";
            var journal_ids = _.flatten(_.map(self.AccountJournal, function (item) {
                return item.id;
            }));
            if (journal_ids){
                filter=filter.concat(",['journal_id', 'in',["+journal_ids+"]]");
            }
            filter=filter.concat("]");
            var field =['id', 'type', 'number', 'origin', 'state', 'journal_id', 'currency_id', 'invoice_line','date_invoice','partner_id'];
            var defer = $.Deferred();
            var AccountInvoice = new model.web.Model('account.invoice');
            AccountInvoice.query(field).filter(filter).all().then(function (results) {
                defer.resolve(results);
            });
            return defer;
        },

        // Invoice line (Linea de Factura)
        fetchAccountInvoiceLine: function () {
            var self = this;
            var defer = $.Deferred();
            var linesIds = _.flatten(_.map(self.AccountInvoice, function (item) {
                return item.invoice_line;
            }));
            var AccountInvoiceLine = new model.web.Model('account.invoice.line');
            AccountInvoiceLine.query(['id', 'quantity', 'price_unit', 'discount', 'name', 'product_id', 'origin','invoice_id']).filter([['id', 'in', linesIds]]).all().then(function (results) {
                defer.resolve(results)
            });
            return defer;
        },

        // clientes
        fetchResPartner: function () {
            var self = this;
            var defer = $.Deferred();
            var fields = ['id','name','ruc'];
            var domain = [['active', '=', true],['customer', '=', true]];
            var ResPartner = new model.web.Model('res.partner');
            ResPartner.query(fields).filter(domain).all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },

        fetchResCurrency : function(){
            var self = this;
            var defer = $.Deferred();
            var fields = ['id','name', 'symbol', 'rate_silent', 'base', 'decimal_separator', 'decimal_places', 'thousands_separator', 'symbol_position'];
            var domain = [['active', '=', true]];
            var ResCurrency = new model.web.Model('res.currency');
            ResCurrency.query(fields).filter(domain).all().then(function(results) {
                defer.resolve(results);
            });
            return defer;
        },

        // Buscar Category
        fetchProductCategory : function(){
            var self = this;
            var defer = $.Deferred();
            var fields = ['id','name','parent_id','complete_name'];
            var ProductCategory = new model.web.Model('product.category');
            ProductCategory.query(fields).filter().all().then(function(results) {
                defer.resolve(results);
            });
            return defer;
        },

        // Ventas (Point Of Sale)
        fetchPosOrder: function () {
            var self = this;
            var defer = $.Deferred();

            var fields = ['id','number', 'name','partner_id','create_date','lines','table_id','sale_journal','pricelist_id'];
            var domain = [['state', 'not in', ['draft','cancel']]];
            var PosOrder = new model.web.Model('pos.order');
            PosOrder.query(fields).filter(domain).all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },

        // Lineas de venta (Point Of Sale)
        fetchPosOrderLine: function () {
            var self = this;
            var defer = $.Deferred();
            var ids = _.flatten(_.map(self.PosOrder, function (item) {
                return item.lines;
            }));
            var fields = ['id', 'name', 'order_id', 'product_id', 'qty', 'price_unit', 'price_subtotal_incl']
            var domain = [['order_id', 'in', ids]];
            var PosOrderLine = new model.web.Model('pos.order.line');
            PosOrderLine.query().filter(domain).all().then(function (results) {
                defer.resolve(results);
            });
            return defer;
        },

        // Product Product
        fetchProductProduct: function(){
            var self = this;
            var product_ids = _.flatten(_.map(self.AccountInvoiceLine, function (item) {
                return item.product_id[0];
            }));
            var modules = self.checkModel('point_of_sale');
            if (modules.length > 0){
                var product_order_ids =  _.flatten(_.map(self.PosOrderLine, function (item) {
                    return item.product_id[0];
                }));
                product_ids = product_ids.concat(product_order_ids);
            }

            var domain = [['id','in',product_ids]];
            var ProductProduct = new model.web.Model('product.product');
            return ProductProduct.call('getProductProduct',[domain], {
                context: new model.web.CompoundContext()
            });
        },

        fetchProductAttribute : function(){
            var self = this;
            var defer = $.Deferred();
            var fields = ['id','name'];
            var ProductAttribute = new model.web.Model('product.attribute');
            ProductAttribute.query(fields).filter().all().then(function(results) {
                defer.resolve(results);
            });
            return defer;
        },

        fetchProductAttributeValue : function(){
            var self = this;
            var defer = $.Deferred();
            var fields = ['id','name','attribute_id'];
            var ProductAttributeValue = new model.web.Model('product.attribute.value');
            ProductAttributeValue.query(fields).filter().all().then(function(results) {
                defer.resolve(results);
            });
            return defer;
        },

        getPosOrder: function (id) {
            var self = this;
            return _.filter(self.PosOrder,function (item) {
                return item.id === id;
            })
        },

        // Obtener las lineas de las Facturas
        getProductProduct: function(pro_id){
            var self = this;
            return _.find(self.ProductProduct, function(item){
                return _.contains(pro_id, item.id);
            });
        },


        getAccountJournal: function (id) {
            var self = this;
            return _.filter(self.AccountJournal,function (item) {
                return item.id === id;
            });
        },

        search: function () {
            var self = this;
            var results = self.ResPartner;
            results = _.map(results, function (item) {
                return {
                        label: item.id + '-'+ item.name + ' ' + self.valorNull(item.ruc),
                        value: item.id + '-'+ item.name + ' ' + self.valorNull(item.ruc)
                }
            });
            self.$('#partner').autocomplete({
                source: results,
                minLength:0,
                search: function(event, ui) {
                    if (!(self.$('#partner').val())){
                        self.fectSearch();
                    }
                },
                close: function( event, ui ) {
                        self.fectSearch();
                },
                select: function(event, ui) {
                    self.fectSearch();
                }
            });
        },

        getAccountInvoice: function (id) {
            var self = this;
            return _.filter(self.AccountInvoice,function (item) {
                return item.id === id;
            })
        },

        getProductPricelist: function (id) {
            var self = this;
            return _.filter(self.ProductPricelist,function (item) {
                return item.id === id;
            })
        },

        getResCurrency: function (id) {
            var self = this;
            return _.filter(self.ResCurrency,function (item) {
                return item.id === id;
            })
        },

        BuildTable: function(){
            var self = this;
           var CurrencyBase = self.getResCurrency(self.resCompany[0].currency_id[0]).shift();
            var data = [];
            var sale;
            var itemsale;
            var saleproducto = [];
            var item;

                for (var k = 0; k < this.PosOrderLine.length; k++) {
                    item = this.PosOrderLine[k];
                    var order = self.getPosOrder(item.order_id[0]).shift();
                    var utc = moment.utc(item.create_date,'YYYY-MM-DD h:mm:ss A');
                    var date = moment(utc._d).format('DD/MM/YYYY h:mm A');
                    var date_aux=moment(utc._d).format('YYYY-MM-DD');
                    var pricelist = self.getProductPricelist(order.pricelist_id[0]).shift();
                    var currency = self.getResCurrency(pricelist.currency_id[0]).shift();
                    var product = this.getProductProduct(item.product_id);

                    if (product != undefined){
                        var store = self.getAccountJournal(order.sale_journal[0]);
                        if(store.length > 0){
                            data.push({
                                id : item.id,
                                order_id : item.order_id[0],
                                order_name: item.order_id[1],
                                ref : "",
                                invoice_name : "",
                                partner_id : order.partner_id[0],
                                product_id : item.product_id[0],
                                number : order.name,
                                date : date_aux,
                                date_order : date,
                                partner : order.partner_id[1],
                                product_name : item.product_id[1],
                                price_unit_total : accounting.formatMoney(item.price_unit * (CurrencyBase.rate_silent / currency.rate_silent), '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                                price_subtotal_total : accounting.formatMoney(item.price_subtotal * (CurrencyBase.rate_silent / currency.rate_silent), '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                                amount_total : accounting.formatMoney((item.price_unit * item.qty) * (CurrencyBase.rate_silent / currency.rate_silent), '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                                price_unit : accounting.formatNumber(item.price_unit * (CurrencyBase.rate_silent / currency.rate_silent),0,".",","),
                                qty : accounting.formatNumber(item.qty,0,".",","),
                                standard_price : accounting.formatNumber((product.standard_price),0, ".", ","),
                                price_tot : accounting.formatNumber((item.qty * item.price_unit),0, ".", ","),
                                standar_tot : accounting.formatNumber((item.qty * product.standard_price),0, ".", ","),
                                utility : accounting.formatNumber(((item.qty * item.price_unit) - (item.qty * product.standard_price)),0, ".", ","),
                                qty_total : item.qty,
                                price_tot_tot : ((item.qty * item.price_unit)),
                                standar_tot_tot : ((item.qty * product.standard_price)),
                                price_subtotal : item.price_subtotal * (CurrencyBase.rate_silent / currency.rate_silent),
                                category_name : product.categ_id.complete_name,
                                category_id : product.categ_id.id,
                                utility : accounting.formatNumber((((item.qty * item.price_unit)* (CurrencyBase.rate_silent / currency.rate_silent)) - (item.qty * product.standard_price)),0, ".", ","),
                                attribute_ids : product.attribute_ids,
                                attribute_value_ids : product.atribute_value_ids,
                                utility_tot : ((((item.qty * item.price_unit) * (CurrencyBase.rate_silent / currency.rate_silent)) - (item.qty * product.standard_price))),
                                store_id : store[0].store_ids[0],
                            });
                        }
                    }
                }


                for (var i = 0; i < this.AccountInvoiceLine.length; i++) {
                   item = this.AccountInvoiceLine[i];
                    var invoice = self.getAccountInvoice(item.invoice_id[0]).shift();
                    var currency = self.getResCurrency(invoice.currency_id[0]).shift();
                    var product = this.getProductProduct(item.product_id);
                    if (!product){
                            product={};
                            product.standard_price=0;
                            product.categ_id="";
                    }
                    if (product != undefined){
                        var storeVenta = self.getAccountJournal(invoice.journal_id[0]);
                        if(storeVenta.length > 0){
                            data.push({
                                id : item.id,
                                order_id : "",
                                order_name: "",
                                ref : item.invoice_id[0],
                                invoice_name : item.invoice_id[1],
                                partner_id : invoice.partner_id[0],
                                product_id : item.product_id[0],
                                number : invoice.number,
                                date : date_aux,
                                date_order : date,
                                partner : invoice.partner_id[1],
                                product_name : item.product_id[1],
                                price_unit_total : accounting.formatMoney(item.price_unit * (CurrencyBase.rate_silent / currency.rate_silent), '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                                price_subtotal_total : accounting.formatMoney(item.price_subtotal * (CurrencyBase.rate_silent / currency.rate_silent), '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                                amount_total : accounting.formatMoney((item.price_unit * item.quantity) * (CurrencyBase.rate_silent / currency.rate_silent), '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                                price_unit : accounting.formatNumber(item.price_unit * (CurrencyBase.rate_silent / currency.rate_silent),0,".",","),
                                qty : accounting.formatNumber(item.quantity,0,".",","),
                                standard_price : accounting.formatNumber((product.standard_price),0, ".", ","),
                                price_tot : accounting.formatNumber((item.quantity * item.price_unit),0, ".", ","),
                                standar_tot : accounting.formatNumber((item.quantity * product.standard_price),0, ".", ","),
                                utility : accounting.formatNumber(((item.quantity * item.price_unit) - (item.quantity * product.standard_price)),0, ".", ","),
                                qty_total : item.quantity,
                                price_tot_tot : ((item.quantity * item.price_unit)),
                                standar_tot_tot : ((item.quantity * product.standard_price)),
                                price_subtotal : item.price_subtotal * (CurrencyBase.rate_silent / currency.rate_silent),
                                category_name : product.categ_id.complete_name,
                                category_id : product.categ_id.id,
                                utility : accounting.formatNumber((((item.quantity * item.price_unit)* (CurrencyBase.rate_silent / currency.rate_silent)) - (item.quantity * product.standard_price)),0, ".", ","),
                                attribute_ids : product.attribute_ids,
                                attribute_value_ids : product.atribute_value_ids,
                                utility_tot : ((((item.quantity * item.price_unit) * (CurrencyBase.rate_silent / currency.rate_silent)) - (item.quantity * product.standard_price))),
                                store_id : storeVenta[0].store_ids[0],
                            });
                        }
                    }
                }

            this.rowsData=data;
            self.content=data;
            this.loadTable(data)
        },

        fectSearch: function(){
            var self = this;
            var today = moment().format('YYYY-MM-DD');
            var yesterday = moment().add(-1, 'days').format('YYYY-MM-DD');
            var month = moment().format('YYYY-MM');
            var last_month = moment().add(-1, 'months').format('YYYY-MM');
            var desde =this.$el.find('#from').val();
            var hasta =this.$el.find('#to').val();
            var store = this.$el.find('#current-store').val();
            var categ_ids = [];
            var category = self.$el.find('#current-category').val();
            var attribute = self.$el.find('#current-attribute').val();
            var attribute_value = self.$el.find('#current-attribute-value').val();
            var partner= this.$el.find('#partner').val().split('-');
            var product = this.$el.find('#product').val().split('-');
            var content = self.content;

            // Hoy
            if ($('#A').is(":checked")){
                content = _.filter(content, function (inv){
                    return moment(inv.date).format('YYYY-MM-DD') == today;
                });
            }
            if ($('#B').is(":checked")){
                content = _.filter(content, function (inv){
                    return moment(inv.date).format('YYYY-MM-DD') == yesterday;
                });
            }
            if ($('#C').is(":checked")){
                content = _.filter(content, function (inv){
                    return moment(inv.date).format('YYYY-MM') == month;
                });
            }
            if ($('#D').is(":checked")){
                content = _.filter(content, function (inv){
                    return moment(inv.date).format('YYYY-MM') == last_month;
                });
            }
            if ($('#Z').is(":checked")){
                $('#datepicker').css('display','block');
                if (desde.length > 0){
                    var date= desde.split('/');
                    content = _.filter(content, function (inv){
                        return inv.date >= (date[2]+"-"+date[1]+"-"+date[0]);
                    });
                }
                if (hasta.length > 0){
                    var date= hasta.split('/');
                    content = _.filter(content, function (inv){
                        return inv.date <= (date[2]+"-"+date[1]+"-"+date[0]);
                    });
                }
            }else{
                $('#datepicker').css('display','none');
            }

            // Buscar Producto
            if (product != ""){
                content = _.filter(content, function(inv){
                    return inv.product_id == product[0];
                });
            }

            if(category){
                // Nivel 0, nivel 1
                var category_ids = _.map(_.filter(self.ProductCategory,function (item) {
                    return item.id == category || item.parent_id[0] == category;
                }), function(map){
                    return map.id;
                });

                // Nivel 0, nivel 1, nivel 2
                var category_children_ids = _.map(_.filter(self.ProductCategory,function (item) {
                    return _.contains(category_ids, item.parent_id[0]) || item.id == category;
                }), function(map){
                    return map.id;
                });

                var category_grandchildren_ids = _.map(_.filter(self.ProductCategory,function (item) {
                    return _.contains(category_children_ids, item.parent_id[0]) || item.id == category;
                }), function(map){
                    return map.id;
                }) ;

                categ_ids =  _.map(_.filter(self.ProductCategory,function (item) {
                    return _.contains(category_grandchildren_ids, item.parent_id[0]) || item.id == category;
                }), function(map){
                    return map.id;
                });
            };

            if(category && category != 9999999){
                content = _.filter(content,function (inv) {
                    return _.contains(categ_ids, inv.category_id);
                });
            }

            if(attribute && attribute != 9999999 && attribute_value == 9999999){
                content = _.filter(content,function (inv) {
                    return _.contains(inv.attribute_ids, parseInt(attribute));
                });
            }

            if(attribute_value && attribute_value != 9999999){
                content = _.filter(content,function (inv) {
                    return _.contains(inv.attribute_value_ids, parseFloat(attribute_value));
                });
            }

            if (partner != ""){
                content = _.filter(content, function(inv){
                    return inv.partner_id == partner[0];
                });
            }

            if (store != 9999999){
                content=_.filter(content, function (inv){
                    return inv.store_id == store;
                });
            }

            var qty_total_total = _.reduce(_.map(content,function(map){
                return(map.qty_total);
            }),function(memo, num){
                return memo + num;
            },0);

            var price_total_total = _.reduce(_.map(content,function(map){
                return(map.price_tot_tot);
            }),function(memo, num){
                return memo + num;
            },0);

            var standar_total_total = _.reduce(_.map(content,function(map){
                return(map.standar_tot_tot);
            }),function(memo, num){
                return memo + num;
            },0);

            var utilidad_total_total = _.reduce(_.map(content,function(map){
                return(map.utility_tot);
            }),function(memo, num){
                return memo + num;
            },0);

            content.push({
                order_name: "Total",
                qty: accounting.formatNumber((qty_total_total),0,".",","),
                price_tot: accounting.formatNumber((price_total_total),0,".",","),
                standar_tot: accounting.formatNumber((standar_total_total),0,".",","),
                utility: accounting.formatNumber((utilidad_total_total),0,".",","),
            });

            self.loadTable(content)
        },

        searchProduct: function () {
            var self = this;
            var results = self.ProductProduct;
            results = _.map(results, function (item) {
                return {
                    label: item.id + '- '+ ' [ ' + self.valorNull(item.default_code) + ' - ' + self.valorNull(item.ean13) + ' ] ' + item.name + ' ( ' +  self.valorNull(item.attribute_str) + ' ) ' ,
                    value: item.id + '- '+ ' [ ' + self.valorNull(item.default_code) + ' - ' + self.valorNull(item.ean13) + ' ] ' + item.name + ' ( ' +  self.valorNull(item.attribute_str) + ' ) '
                }
            });
            self.$('#product').autocomplete({
                source: results,
                minLength:0,
                search: function(event, ui) {
                    if (!(self.$('#product').val())){
                        self.fectSearch();
                    }
                },
                close: function( event, ui ) {
                        self.fectSearch();
                },
                select: function(event, ui) {
                    self.fectSearch();
                }
            });
        },

        loadTable:function(rowsTable){
            var self = this;
            self.rowsData = rowsTable;
            var table = this.$el.find('#table');
            table.bootstrapTable('load',rowsTable);
        },

        getObjetPdf: function(rowsTable){
            var self = this;
            var rows=[];
            var rows = self.rowsData;

            return rows;
        },

        clickOnAction: function (e) {
            var self = this;
            var rowsNew;
            var action = this.$el.find(e.target).val();
            var table = this.$el.find("#table");
            var data2 = table.bootstrapTable('getVisibleColumns');
            var getColumns=[];
            var rows=[];
            rowsNew = self.getObjetPdf();

            if (action === 'pdf') {
                var dataNEW = _.map(data2, function (val){ return val.field});
                _.each(rowsNew,function (item){
                    rows.push(_.pick(item, dataNEW));
                });
                // Obtener los nombre de la Cabezera
                _.each(_.map(data2,function(val){
                    return val}), function(item){
                    getColumns.push([{
                                    title: item.title,
                                    dataKey: item.field
                                }]);
                });
                // Llamar al pdf
                this.drawPDF(_.flatten(getColumns),rows)
            }
        },

        drawPDF: function (getColumns,rows) {
            var self = this;
            var desde =(this.$el.find('#from').val());
            var hasta =(this.$el.find('#to').val());
            var totalPagesExp = "{total_pages_count_string}";
            var pdfDoc = new jsPDF('l');

            pdfDoc.autoTable(getColumns, rows, {
                styles: { overflow: 'linebreak', fontSize: 7, columnWidth: 'wrap'},
                columnStyles: {
                        order_name: {halign:'left'},
                        ref: {halign:'left', fontStyle: 'bold'},
                        date_order :{columnWidth: 26, halign:'left'},
                        partner :{columnWidth: 25, halign:'left' },
                        product_name :{columnWidth: 65, halign:'left' },
                        qty :{halign:'right',columnWidth: 9},
                        price_unit : {halign:'right',columnWidth: 15},
                        standard_price : {halign:'right',columnWidth: 18},
                        price_tot : {halign:'right' ,columnWidth: 20},
                        standar_tot : {halign:'right' ,columnWidth: 20},
                        utility : {halign:'right',columnWidth: 19}
                    },
                margin: { top: 16, horizontal: 7},
                addPageContent: function (data) {
                    pdfDoc.setFontSize(12);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text('Análisis de Ventas generales', data.settings.margin.left, 10);

                    if(desde.length > 0 || hasta.length > 0){
                      var fecha='';
                      if(desde){
                        fecha=fecha.concat(' Desde '+desde);
                      }
                      if (hasta){
                        fecha=fecha.concat(' Hasta '+hasta);
                      }
                        pdfDoc.setFontSize(10);
                        pdfDoc.setFontStyle('bold');
                        pdfDoc.setTextColor(40)
                        pdfDoc.text(fecha, data.settings.margin.left,14);
                    }
                    // FOOTER
                    var str = "Pagina  " + data.pageCount;
                    // Total page number plugin only available in jspdf v1.0+
                    if (typeof pdfDoc.putTotalPages === 'function') {
                        str = str + " de " + totalPagesExp;
                    }
                    pdfDoc.setFontSize(9);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(str, data.settings.margin.left, pdfDoc.internal.pageSize.height - 5);
                }
            });

            if (typeof pdfDoc.putTotalPages === 'function') {
                pdfDoc.putTotalPages(totalPagesExp);
            }
            pdfDoc.save('Análisis de ventas generales.pdf')
        },
    });
}
